/*	ColorPicker v1.2 by L.K. Toh
	Last revised 07/05/2001 dedicated to L.J.W
	Please contact me at lktoh@navsurf.com for any comments or suggestions
	The source code is strictly for educational purposes and cannot be modified
	or used without the express permission of the author
	Visit http://navsurf.com for the latest version and other useful applets
*/

/*	sample applet for colorpicker
    <applet code=colorpicker.class width=400 height=450>
    </applet>
*/

import java.applet.Applet;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.awt.*;
import java.awt.event.*;

public class colorpicker extends Applet
 implements MouseListener, MouseMotionListener, AdjustmentListener{

CanvasHS chs = new CanvasHS();
CanvasB cb = new CanvasB();

TextField tf_hc = new TextField("808080", 6);

Scrollbar sb_r = new Scrollbar(Scrollbar.HORIZONTAL, 127, 20, 0, 275);
Scrollbar sb_g = new Scrollbar(Scrollbar.HORIZONTAL, 127, 20, 0, 275);
Scrollbar sb_b = new Scrollbar(Scrollbar.HORIZONTAL, 127, 20, 0, 275);

Label l_r = new Label("127", Label.RIGHT);
Label l_g = new Label("127", Label.RIGHT);
Label l_b = new Label("127", Label.RIGHT);

Canvas cc = new Canvas();

public void init(){
	setLayout(new BorderLayout());
	setFont(new Font("Arial", Font.BOLD, 12));
	setBackground(Color.white);

	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();

	Panel p_canvas = new Panel(new FlowLayout(FlowLayout.CENTER, 20, 20));
	Panel p_display = new Panel(new FlowLayout(FlowLayout.CENTER, 10, 0));
	Panel p_field = new Panel(gridbag);

	Canvas c_r = new Canvas();
	Canvas c_g = new Canvas();
	Canvas c_b = new Canvas();

	c_r.resize(20, 20);
	c_r.setBackground(Color.red);

	c_g.resize(20, 20);
	c_g.setBackground(Color.green);

	c_b.resize(20, 20);
	c_b.setBackground(Color.blue);

	chs.addMouseMotionListener(this);
	chs.addMouseListener(this);
	cb.addMouseMotionListener(this);
	cb.addMouseListener(this);

	p_canvas.add(chs);
	p_canvas.add(cb);

	cc.resize(50, 50);
	cc.setBackground(Color.gray);

	sb_r.addAdjustmentListener(this);
	sb_g.addAdjustmentListener(this);
	sb_b.addAdjustmentListener(this);

	add(p_canvas, "North");

	c.anchor = GridBagConstraints.CENTER;
	c.insets = new Insets(5, 5, 5, 5);

	c.ipadx = 0;
	c.weightx = 0;

	c.fill = GridBagConstraints.BOTH;

	p_field.add(l_r, c);
	p_field.add(c_r, c);

	c.ipadx = 250;
	c.gridwidth = GridBagConstraints.REMAINDER;
	p_field.add(sb_r, c);

	c.ipadx = 0;
	c.gridwidth = 1;

	p_field.add(l_g, c);
	p_field.add(c_g, c);

	c.ipadx = 250;
	c.gridwidth = GridBagConstraints.REMAINDER;
	p_field.add(sb_g, c);

	c.ipadx = 0;
	c.gridwidth = 1;

	p_field.add(l_b, c);
	p_field.add(c_b, c);

	c.ipadx = 250;
	c.gridwidth = GridBagConstraints.REMAINDER;
	p_field.add(sb_b, c);

	p_display.add(new Label("Hex Code"));
	p_display.add(tf_hc);
	p_display.add(cc);

	add(p_field, "Center");
	add(p_display, "South");
}

public void mouseClicked( MouseEvent e ){
	processEvent(e);
}
public void mouseEntered( MouseEvent e ){}
public void mouseExited( MouseEvent e ){}
public void mouseReleased( MouseEvent e ){}
public void mousePressed( MouseEvent e ){}

public void mouseDragged( MouseEvent e ){
	processEvent(e);
}
public void mouseMoved( MouseEvent e ){}

public void adjustmentValueChanged(AdjustmentEvent ae){
	Color cur_color = new Color(sb_r.getValue(),
								sb_g.getValue(),
								sb_b.getValue());

	updateText(cur_color);
	cb.setCursor(cb.size().height/2);
	cb.refresh(cur_color);
	cc.setBackground(cur_color);
};

public final void updateText(Color cur_color){
	String Strhex = Integer.toHexString(cur_color.getRGB() & 0xFFFFFF).toUpperCase();
	Strhex = "000000" + Strhex;
	Strhex = Strhex.substring(Strhex.length() - 6);

	tf_hc.setText(Strhex);
	l_r.setText(Integer.toString(cur_color.getRed()));
	l_g.setText(Integer.toString(cur_color.getGreen()));
	l_b.setText(Integer.toString(cur_color.getBlue()));
}

private void processEvent( MouseEvent e){
	if (e.getComponent() instanceof CanvasHS){
		cb.refresh(chs.getColorAt(e.getX(), e.getY()));
		cb.repaint();
		Color cur_color = cb.getColor();
		sb_r.setValue(cur_color.getRed());
		sb_g.setValue(cur_color.getGreen());
		sb_b.setValue(cur_color.getBlue());
		updateText(cur_color);
		cc.setBackground(cur_color);
	}

	if (e.getComponent() instanceof CanvasB){
		Color cur_color = cb.getColorAt(e.getX(), e.getY());
		sb_r.setValue(cur_color.getRed());
		sb_g.setValue(cur_color.getGreen());
		sb_b.setValue(cur_color.getBlue());
		updateText(cur_color);
		cb.setCursor(e.getY());
		cb.repaint();
		cc.setBackground(cur_color);
	}
}

public void paint(Graphics g){}
}
